% Copyright is with the following author(s):
%
% (c) 2012 Juraj Oravec, Slovak University of Technology in Bratislava,
% juraj.oravec@stuba.sk
% (c) 2012 Monika Bakosova, Slovak University of Technology in Bratislava,
% monika.bakosova@stuba.sk
% ------------------------------------------------------------------------------
% Legal note:
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public
% License along with this library; if not, write to the
% Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330,
% Boston, MA 02111-1307 USA
%
% ------------------------------------------------------------------------------

function pid_get_param(flag)

% Load DaTA
%
data = get(findobj('Tag','pid_tune'),'Userdata');

kp = data.kp;
ki = data.ki;
kd = data.kd;

% Input
%
if(flag == 's')
    kp = get(findobj('Tag','pid_s_kp'),'Value');
    ki = get(findobj('Tag','pid_s_ki'),'Value');
    kd = get(findobj('Tag','pid_s_kd'),'Value');
elseif(flag == 'e')
    kp = str2num(get(findobj('Tag','pid_e_kp'),'String'));
    ki = str2num(get(findobj('Tag','pid_e_ki'),'String'));
    kd = str2num(get(findobj('Tag','pid_e_kd'),'String'));
elseif(flag == 'c')
    data.val_c_nom = get(findobj('Tag','pid_c_nom'),'Value');
elseif(flag == 'x')
    set(findobj('Tag','pid_e_nom'),'String',data.error_nom);

end

kp = pid_chk_param(data.kp,kp,data.kp_min,data.kp_max);
ki = pid_chk_param(data.ki,ki,data.ki_min,data.ki_max);
kd = pid_chk_param(data.kd,kd,data.kd_min,data.kd_max);

data.kp = kp;
data.ki = ki;
data.kd = kd;

% Refresh values
%
set(findobj('Tag','pid_s_kp'),'Value',kp);
set(findobj('Tag','pid_s_ki'),'Value',ki);
set(findobj('Tag','pid_s_kd'),'Value',kd);

set(findobj('Tag','pid_e_kp'),'String',kp);
set(findobj('Tag','pid_e_ki'),'String',ki);
set(findobj('Tag','pid_e_kd'),'String',kd);

% Store DATA
%
set(findobj('Tag','pid_tune'),'Userdata',data);

% Simulation of Control
%
pid_tune_sim