% Copyright is with the following author(s):
%
% (c) 2012 Juraj Oravec, Slovak University of Technology in Bratislava,
% juraj.oravec@stuba.sk
% (c) 2012 Monika Bakosova, Slovak University of Technology in Bratislava,
% monika.bakosova@stuba.sk
% ------------------------------------------------------------------------------
% Legal note:
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public
% License along with this library; if not, write to the
% Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330,
% Boston, MA 02111-1307 USA
%
% ------------------------------------------------------------------------------

function pid_var_sim_tsim = pid_get_simtime

data = get(findobj('Tag','pid_tune'),'Userdata');

kp = data.kp;
ki = data.ki;
kd = data.kd;
nom_num = data.num;
nom_den = data.den;
nom_td = data.td;

chr = conv( conv([1 0],nom_den), conv([kd, kp ki], nom_num) );
chr_roots = roots(chr);
chr_roots_2 = [];
for k = 1 : length(chr_roots)
    if (chr_roots(k) ~= 0)
        chr_roots_2 = [chr_roots_2;chr_roots(k)];
    end
end

chr_roots_2 = min(abs(real(chr_roots_2)));
chr_roots_2 = chr_roots_2(1);
pid_var_sim_tsim = 1/chr_roots_2*6.28 + nom_td;