% Copyright is with the following author(s):
%
% (c) 2012 Juraj Oravec, Slovak University of Technology in Bratislava,
% juraj.oravec@stuba.sk
% (c) 2012 Monika Bakosova, Slovak University of Technology in Bratislava,
% monika.bakosova@stuba.sk
% ------------------------------------------------------------------------------
% Legal note:
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public
% License along with this library; if not, write to the
% Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330,
% Boston, MA 02111-1307 USA
%
% ------------------------------------------------------------------------------

function pid_tune_sim

% Simulation of control
%

data = get(findobj('Tag','pid_tune'),'Userdata');

global pid_var_kp pid_var_ki pid_var_kd pid_var_sim_num pid_var_sim_den pid_var_sim_td pid_var_weight_y pid_var_weight_u pid_var_sim_tsim

% % Simulation time TSIM evaluation
% %
pid_var_sim_tsim = pid_get_simtime;

pid_var_kp = data.kp;
pid_var_ki = data.ki;
pid_var_kd = data.kd;

% Figure
%
if(isempty(findobj('Tag','pid_tune_fig')) == 1)
    hf2 = figure;
    set(hf2,'Name','PID_TUNE_RESULTS',...
        'Tag','pid_tune_fig',...
        'Numbertitle','off',...
        'Color','w')
    %'Menubar','none',...

end

figure(findobj('Tag','pid_tune_fig'))
subplot(1,1,1)

subplot(2,1,1)
xlabel('time')
ylabel('y(t)')
hold on
box on
subplot(2,1,2)
xlabel('time')
ylabel('u(t)')
hold on
box on

if(data.val_c_nom)
    pid_var_sim_num = data.num;
    pid_var_sim_den = data.den;
    pid_var_sim_td = data.td;
    pid_var_weight_y = data.weight_y;
    pid_var_weight_u = data.weight_u;

sim('pid_sim')

t = pid_data_sim(:,1);
y = pid_data_sim(:,2);
u = pid_data_sim(:,3);
subplot(2,1,1)
plot(t,y,'b-','Linewidth',2)
subplot(2,1,2)
plot(t,u,'r-','Linewidth',2)

% Square Error - NOM
%
set(findobj('Tag','pid_e_nom'),'String',num2str(pid_var_cost))
else
    set(findobj('Tag','pid_e_nom'),'String',num2str(-Inf))

end
